- Main Page
- Modules
- Data Structures
- Files
- Related Pages

- Data Structures
- Data Fields

# __CPU_Private_Data Struct Reference
[NPF structures and definitions]

Kernel buffer of each CPU. More...

`#include <Packet.h>`

## Data Fields
ULONG | P
| Zero-based index of the producer in the buffer. It indicates the first free byte to be written.
ULONG | C
| Zero-based index of the consumer in the buffer. It indicates the first free byte to be read.
ULONG | Free
| Number of the free bytes in the buffer.
PUCHAR | Buffer
| Pointer to the kernel buffer used to capture packets.
ULONG | Accepted
ULONG | Received
ULONG | Dropped
NDIS_SPIN_LOCK | BufferLock
| It protects the buffer associated with this CPU.
PMDL | TransferMdl1
| MDL used to map the portion of the buffer that will contain an incoming packet.
PMDL | TransferMdl2
| Second MDL used to map the portion of the buffer that will contain an incoming packet.
ULONG | NewP
| Used by NdisTransferData() (when we call NdisTransferData, p index must be updated only in the TransferDataComplete.

## Detailed Description

Kernel buffer of each CPU.

Structure containing the kernel buffer (and other CPU related fields) used to capture packets.

Definition at line 327 of file Packet.h.

## Field Documentation

ULONG P

Zero-based index of the producer in the buffer. It indicates the first free byte to be written.

Definition at line 329 of file Packet.h.

ULONG C

Zero-based index of the consumer in the buffer. It indicates the first free byte to be read.

Definition at line 330 of file Packet.h.

ULONG Free

Number of the free bytes in the buffer.

Definition at line 331 of file Packet.h.

PUCHAR Buffer

Pointer to the kernel buffer used to capture packets.

Definition at line 332 of file Packet.h.

ULONG Accepted

Number of packet that current capture instance acepted, from its opening. A packet is accepted if it passes the filter and fits in the buffer. Accepted packets are the ones that reach the application. This number is related to the particular CPU this structure is referring to.

Definition at line 333 of file Packet.h.

ULONG Received

Number of packets received by current instance from its opening, i.e. number of packet received by the network adapter since the beginning of the capture/monitoring/dump session. This number is related to the particular CPU this structure is referring to.

Definition at line 337 of file Packet.h.

ULONG Dropped

Number of packet that current instance had to drop, from its opening. A packet is dropped if there is no more space to store it in the circular buffer that the driver associates to current instance. This number is related to the particular CPU this structure is referring to.

Definition at line 341 of file Packet.h.

NDIS_SPIN_LOCK BufferLock

It protects the buffer associated with this CPU.

Definition at line 345 of file Packet.h.

PMDL TransferMdl1

MDL used to map the portion of the buffer that will contain an incoming packet.

Definition at line 346 of file Packet.h.

PMDL TransferMdl2

Second MDL used to map the portion of the buffer that will contain an incoming packet.

Definition at line 347 of file Packet.h.

ULONG NewP

Used by NdisTransferData() (when we call NdisTransferData, p index must be updated only in the TransferDataComplete.

Definition at line 348 of file Packet.h.

The documentation for this struct was generated from the following file:

- Packet.h

documentation. Copyright (c) 2002-2005 Politecnico di Torino. Copyright (c) 2005-2007 CACE Technologies. All rights reserved.